import enum

A_PROCESSING_TIME: float = 3.0
INITIAL_DELAY_MIN: float = 0.0
INITIAL_DELAY_MAX: float = 3
REQUEST_RESPONSE_DELAY_MIN: float = 0.01
REQUEST_RESPONSE_DELAY_MAX: float = 0.05
REPETITION_MAX: float = 3
REPETITION_BASE_DELAY: float = 0.01
CYCLIC_OFFER_DELAY: float = 1.0
FIND_TTL: int = 3
MULTICAST_ADDRESS: str = "224.0.0.171"
MULTICAST_PORT: int = 30490


class SOMEIPMessageType(enum.IntEnum):
    REQUEST = 0x00
    REQUEST_NO_RETURN = 0x01
    NOTIFICATION = 0x02
    REQUEST_ACK = 0x40
    REQUEST_NO_RETURN_ACK = 0x41
    NOTIFICATION_ACK = 0x42
    RESPONSE = 0x80
    ERROR = 0x81
    RESPONSE_ACK = 0xC0
    ERROR_ACK = 0xC1


class SOMEIPTPMessageType(enum.IntEnum):
    TYPE_REQUEST_SEGMENT = 0x20
    TYPE_REQUEST_NO_RET_SEGMENT = 0x21
    TYPE_NOTIFICATION_SEGMENT = 0x22
    TYPE_REQUEST_ACK_SEGMENT = 0x60
    TYPE_REQUEST_NORET_ACK_SEGMENT = 0x61
    TYPE_NOTIFICATION_ACK_SEGMENT = 0x62
    TYPE_RESPONSE_SEGMENT = 0xA0
    TYPE_ERROR_SEGMENT = 0xA1
    TYPE_RESPONSE_ACK_SEGMENT = 0xE0
    TYPE_ERROR_ACK_SEGMENT = 0xE1


class SOMEIPReturnCode(enum.IntEnum):
    E_OK = 0
    E_NOT_OK = 1
    E_UNKNOWN_SERVICE = 2
    E_UNKNOWN_METHOD = 3
    E_NOT_READY = 4
    E_NOT_REACHABLE = 5
    E_TIMEOUT = 6
    E_WRONG_PROTOCOL_VERSION = 7
    E_WRONG_INTERFACE_VERSION = 8
    E_MALFORMED_MESSAGE = 9
    E_WRONG_MESSAGE_TYPE = 10


class SOMEIPSDEntryType(enum.IntEnum):
    FindService = 0
    OfferService = 1
    Subscribe = 6
    SubscribeAck = 7
